unit VENDA;
// Exemplo de Cupom Fiscal
// ECF SWEDA Verso 1.1

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    BtFechar: TButton;
    Button1: TButton;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Com1: TRadioButton;
    Com2: TRadioButton;
    Com3: TRadioButton;
    COm4: TRadioButton;
    procedure BtFecharClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Com1Click(Sender: TObject);
    procedure Com2Click(Sender: TObject);
    procedure Com3Click(Sender: TObject);
    procedure COm4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Comando: array[0..512] of Char;
  Resposta:String;
  Function AbrePorta(Numero,Timeout:Integer):Boolean; far; Export;
  external 'SERSWEDA.DLL' index 1;
  Function EnviaComando(Texto1:PChar):ShortString; far; Export;
  external 'SERSWEDA.DLL' index 2;
  Function FechaPorta(Numero:Integer):Boolean; far; Export;
  external 'SERSWEDA.DLL' index 3;

Implementation

{$R *.DFM}

procedure TForm1.BtFecharClick(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if not (Com1.Checked or Com2.Checked or COm3.Checked or Com4.checked) then
    begin
        ShowMessage('Selecione a porta serial !');
        GroupBox1.SetFocus;
        Exit;
    end;

    StrPCopy(Comando,#27+'.17123.456.789/02}'); // ABRIR CUPOM FISCAL
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Abrir Cupom:'+Resposta);

    StrPCopy(Comando,#27+'.0178965432109870001000000000100000000000100AGUA                    T01}');
    Resposta:=EnviaCOmando(Comando); //LANAR ITEM DE VENDA
    Memo1.Lines.Add('Lanar Item:'+Resposta);

    StrPCopy(Comando,#27+'.022000000000000020}'); // DESCONTO NO ITEM
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Desconto no item:'+Resposta);

    StrPCopy(Comando,#27+'.0178965432101230001000000000100000000000100LEITE ESPECIAL          I  }');
    Resposta:=EnviaCOmando(Comando); //LANAR ITEM DE VENDA
    Memo1.Lines.Add('Lanar Item:'+Resposta);

    StrPCopy(Comando,#27+'.04}'); // CANCELAMENTO DO ITEM
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Cancelamento de item:'+Resposta);

    StrPCopy(Comando,#27+'.1001000000000500}'); // TOTALIZAR CUPOM FISCAL
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Totalizar Cupom:'+Resposta);

    StrPCopy(Comando,#27+'.09|0|05 001|01 005}');  // LANAR INDICADORES
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Indicadores:'+Resposta);

    StrPCopy(Comando,#27+'.12N0     GRATOS PELA PREFERENCIA ! }'); // FECHAR CUPOM
    Resposta:=EnviaCOmando(Comando);
    Memo1.Lines.Add('Fechar Cupom:'+Resposta);
    Memo1.Lines.Add('');
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
     GroupBox1.SetFocus;
     if not (Com1.Checked or Com2.Checked or Com3.Checked or Com4.Checked) then
     begin
        ShowMessage('Selecione a porta serial !');
        GroupBox1.SetFocus;
     end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     FechaPorta(2);
end;

procedure TForm1.Com1Click(Sender: TObject);
begin
        try
                AbrePorta(1,5);
        except
                ShowMessage('Erro na Abertura da Porta Com1');
        end;
end;

procedure TForm1.Com2Click(Sender: TObject);
begin
        try
                AbrePorta(2,5);
        except
                ShowMessage('Erro na Abertura da Porta Com2');
        end;
end;

procedure TForm1.Com3Click(Sender: TObject);
begin
        try
                AbrePorta(3,5);
        except
                ShowMessage('Erro na Abertura da Porta Com3');
        end;
end;

procedure TForm1.COm4Click(Sender: TObject);
begin
        try
                AbrePorta(4,5);
        except
                ShowMessage('Erro na Abertura da Porta Com4');
        end;
end;

end.
